#!/bin/sh

X=`basename $PWD`
TGT=/tmp/$X-dist

rm -Rf $TGT
rm -f $TGT.tgz

mkdir $TGT || (echo "can not make directory $TGT" && exit)

cp `find . -name '*.[ch]'` $TGT
cp `find -name jj.ref` $TGT
cp `find -name build.sh` $TGT
cp README COPYING COPYRIGHT $TGT

cd /tmp
tar czf $X-dist.tgz $X-dist || (echo "can not make tarball" && exit)

echo all done. file is $X-dist.tgz


