
#if 0


#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include "parser.h"
#include "ddepg.h"
#include "table.h"
#include "functions.h"
#include "string.h"
#include "schedule.h"

#include "main.h"


 static  void
load_file(char* fname, arg_t *rel) ; static  char *relative_path(char *fname,char *rel) ; static  char *
normalize(char *fn) ; static  void
compute_here() ; static  void include_file(arg_t* arg,frame_t *frame) ;
 int option_printmsg= 0;  int option_norun= 0;  int option_noprefix= 0;  int option_graph= 0; 


 char *file_name;

 static  void
load_file(char* fname, arg_t *rel) {
	char *xoldf;
	stmt_t *statements;
	char *err;
	stmt_t *S;

	if (fname[0]!='/') 
		fname= relative_path(fname, rel->tokens.next->data);
	fname= normalize(fname);
	xoldf= file_name;
	file_name= fname;
	compute_here();
	err= parse_file(fname,&statements);
	if (err)
		exit(fprintf(stderr,"parse error in file %s: %s\n",fname,err));
	
	push_callstack(fname, "(top)");
	  {
	void *N4;
	for(S=statements->next;S!=statements;S=N4)  {
		N4= S->next;

		arg_t *result;
		result= exec_stmt(S, &global_frame);
		if (result)
			arg_destroy_deep(result);
	
    } }


	pop_callstack();
	file_name= xoldf;
	if (file_name)
		compute_here();
}

 static  char *relative_path(char *fname,char *rel) {
	char *R;
	int fL= strlen(fname);
	int rL= strlen(rel);
	R= malloc(rL+fL+2);
	memcpy(R, rel, rL);
	R[rL]= '/';
	memcpy(R+rL+1, fname, fL);
	R[rL+fL+1]= 0;
	return R;
}

 static  char *
normalize(char *fn) {
        char *x;
        while((x= strstr(fn,"//")))
                memmove(x,x+1,(strlen(x+1)+1)*sizeof(char));

        while((x=strstr(fn,"/./")))
                memmove(x,x+2,(strlen(x+2)+1)*sizeof(char));

        while((x=strstr(fn,"/../"))) {
                if (x==fn)  {
                        memmove(fn,fn+3,(strlen(x+3)+1 )*sizeof(char));
                } else {
                        char *up;
                        for(up=x-1;*up!='/';up--)
                                ;
                        memmove(up,x+3,(strlen(x+3)+1)*sizeof(char));
                }
        }
        return fn;
}


 arg_t *here;
 arg_t *working_dir;



void main_init() {
	static char wdstore[2000];
	char *wdir= getcwd(wdstore,1990);
	if (!wdir)
		exit(fprintf(stderr,"such long working directories confuse me\n"));
	strcat(wdir,"/");
	if (working_dir)
		arg_destroy_deep(working_dir);
	working_dir= arg_new();
	token_t *T= token_new();
	T->kind= 'W';
	T->data= strdup(wdir);
	 {
	(T)->prev= ((&working_dir->tokens))->prev; 
	(T)->next= ((&working_dir->tokens)); 
	((&working_dir->tokens))->prev->next= (T); 
	((&working_dir->tokens))->prev= (T); 
}


	init_builtin_functions();
}

 static  void
compute_here() {
	int i;
	char *fdir= strdup(file_name);
	int fL= strlen(fdir);
	for(i=fL-1;i&& fdir[i]!='/';i--)
		;
	fdir[i+1]= 0;
	if (here)
		arg_destroy_deep(here);
	here= arg_new();
	token_t *T= token_new();
	T->kind= 'W';
	T->data= fdir;
	 {
	(T)->prev= ((&here->tokens))->prev; 
	(T)->next= ((&here->tokens)); 
	((&here->tokens))->prev->next= (T); 
	((&here->tokens))->prev= (T); 
}


}

 int option_printmsg;

int main(int argc,char **argv) {
	int i;
	int loaded= 0;
	main_init();
	for(i=1;i<argc;i++) {
		


	if (!strcmp(argv[i],"-m")) {
		option_printmsg= 1;
		continue;
	}

		


	if (!strcmp(argv[i],"-n")) {
		option_norun= 1;
		continue;
	}

		


	if (!strcmp(argv[i],"-p")) {
		option_noprefix= 1;
		continue;
	}

		


	if (!strcmp(argv[i],"-g")) {
		option_graph= 1;
		continue;
	}

		if (argv[i][0]!='-') {
			load_file(argv[i], working_dir);
			loaded++;
		}
	}
	if (!loaded)
		load_file("jjcool", working_dir);
	if (option_graph)
		dump_dependency_graph();
	else
		run_commands();
	return 0;
}



arg_t *blt_include(arg_t *call, frame_t *frame) {
	arg_t *A;
	  {
	void *N18;
	for(A=call->next;A!=call;A=N18)  {
		N18= A->next;

		include_file(A, frame);
	
    } }


	return 0;
}

 static  void include_file(arg_t* arg,frame_t *frame) {
	char *name;
	int len;
	len= stringcat(arg, 0, frame);
	name= malloc(len);
	stringcat(arg,name, frame);
	load_file(name,here);
}













