#!/usr/bin/perl

use CGI qw/:standard/;

my $code;

import_names();
Delete_all();

sub Text {
	print escapeHTML($_[0]);
}

sub ListBegin {
	print "<ul>";
}

sub ListEnd {
	print "</ul>";
}

sub PBreak {
	print "<p>";
}

sub ListItem {
	print "<li>";
}

sub Target {
	$link_target=$_[0];
	$link_is_crossref= "yes";
}

sub Web {
	$link_target=$_[0];
	$link_is_crossref= "no";
}

sub Link {
	if ($link_is_crossref eq "yes") {
		printf "<a href=\"%s\">%s</a>", $link_target, escapeHTML($_[0]);
	} else {
		printf "<a href=\"%s\">%s</a>", $link_target, escapeHTML($_[0]);
	}
}

sub Section { }
sub Command { }

sub Red {
	print "<span class=red>", escapeHTML($_[0]), "</span>";
}

sub Bold {
	print "<b>", escapeHTML($_[0]), "</b>";
}

sub Heading4 {
	print "<h4>",escapeHTML($_[0]),"</h4>";
}
sub Heading3 {
	print "<h3>",escapeHTML($_[0]),"</h3>";
}
sub Heading2 {
	print "<h2>",escapeHTML($_[0]),"</h2>";
}
sub Heading1 {
	print "<h1>",escapeHTML($_[0]),"</h1>";
}

sub Code {
	print "<tt>", escapeHTML($_[0]), "</tt>";
}

sub Italic {
	print "<i>", escapeHTML($_[0]), "</i>";
}

sub Verbatim {
	print "<pre>", escapeHTML($_[0]), "</pre>";
}






$fn=$ARGV[0];
shift;


print start_html( -title=> 'Simple Script');

my $line;
if (open INP, $fn) {
	while($line=<INP>) { eval $line; }
	close INP;
}

print end_html;

