
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "parser.h"
#include "table.h"
#include "functions.h"
#include "string.h"














arg_t *blt_getenv(arg_t *call,frame_t *frame) {
	char *varname;
	char *output;
	varname= get_varname(call,0,"env.get");
	output= getenv(varname+1);
	var_set(varname, arg_new_text(output), frame);
	free(varname);
	return 0;
}

arg_t *blt_setenvkill(arg_t *call,frame_t *frame) {
	char *varname;
	arg_t *arg;
	char *txt;
	varname= get_varname(call,0,"env.set.kill");
	arg= var_get(varname,frame);
	if (!arg) {
		txt= "";
	} else {
		txt= arg_to_string_noforce(arg, frame);
	}
	setenv(varname+1, txt,1);
	var_kill(varname, frame);
	free(varname);
	return 0;
}









