
#ifndef EXTLIBS_DOT_H_INCLUDED
#define EXTLIBS_DOT_H_INCLUDED



 enum {
	PROC_INP= 1, PROC_OUTP= 2, PROC_ERR= 4
};
#ifdef __cplusplus
extern "C" {
#endif
 size_t vgenprintf(
	void (*write)(void *arg,const char *buf,size_t len), void *arg,
	const char *fmt, va_list args)
; size_t genprintf(
	void (*write)(void *arg,const char *buf,size_t len),
	  void *arg, const char *fmt, ... )
; size_t fdprintf(int fd, const char *fmt, ...) ; char *vmprintf(const char *fmt, va_list ap) ; size_t vnprintf(const char *fmt, va_list ap) ; char *
mprintf(const char *fmt, ...) ;
int proc_kill(int id,int sig) ;
int proc_start(char *fn,char **argv,int opts) ;
int proc_end(int id,int *st) ;
int proc_input(int id) ;
int proc_output(int id) ;
int proc_error(int id) ;
int proc_islive(int id) ;
int proc_run(char *fn,char **argv,int *arg,char *inp,size_t inp_l,char **outp,size_t *outp_l,char **err,size_t *err_l) ; char* file_read_all(char *fn) ;
#ifdef __cplusplus
}
#endif

#endif
