
#include <stdio.h>
#include <stdlib.h>

#include "table.h"
#include "parser.h"
#include "command.h"

#include "ddepg.h"
 typedef struct cmdlist {
			struct cmdlist *prev, *next;
			strtab_t fields;
		} cmdlist_t;
 static  void insert_files_in(arg_t *A) ;
 static  strtab_t all_files; static  int fno;
		static cmdlist_t all_cmds= { &all_cmds, &all_cmds };
		








 void dump_dependency_graph() {
	
	while(1) {
		strtab_t cmd;
		arg_t *A;
		cmdlist_t *C;
		if (command_get_one(&cmd))
			break;
		
		
		
	C= (typeof(C)) calloc(1, sizeof(C[0]));


		C->fields= cmd;
		 {
	(C)->prev= ((&all_cmds))->prev; 
	(C)->next= ((&all_cmds)); 
	((&all_cmds))->prev->next= (C); 
	((&all_cmds))->prev= (C); 
}


		A= strtab_find(&cmd,"outputs");
		if (A)
			insert_files_in(A);
		A= strtab_find(&cmd,"triggers");
		if (A)
			insert_files_in(A);
	}

	printf("%d\n",fno+1);
	 {
	cmdlist_t *c;
	  {
	void *N23;
	for(c=(&all_cmds)->next;c!=(&all_cmds);c=N23)  {
		N23= c->next;

		arg_t *O;
		arg_t *T;
		token_t *To, *Tt;
		O= strtab_find(&c->fields, "outputs");
		if (!O) continue;
		T= strtab_find(&c->fields, "triggers");
		if (!T) continue;
		  {
	void *N24;
	for(To=(&O->tokens)->next;To!=(&O->tokens);To=N24)  {
		N24= To->next;

			int onr;
			if (To->kind!='W') continue;
			onr= (int) strtab_find(&all_files, To->data);
			  {
	void *N25;
	for(Tt=(&T->tokens)->next;Tt!=(&T->tokens);Tt=N25)  {
		N25= Tt->next;

				int tnr;
				if (Tt->kind!='W') continue;
				tnr= (int) strtab_find(&all_files, Tt->data);
				printf("%d %d\n", tnr, onr);
			
    } }


		
    } }


	
    } }


	printf("0 0\n");
}


	/* dump the file names */
}



 static  void insert_files_in(arg_t *A) {
	token_t *T;
	  {
	void *N8;
	for(T=(&A->tokens)->next;T!=(&A->tokens);T=N8)  {
		N8= T->next;

		if (T->kind!='W') continue;
		if (!strtab_find(&all_files,T->data)) {
			strtab_insert(&all_files, T->data, (void*) fno);
			fno++;
		}
	
    } }


}








