-[ program "test.c" ]



int main(int argc,char **argv) {
	char *err;
	stmt_t *stmts;
	stmt_t *S;
	init_builtin_functions();
	err= parse_file("-" , &stmts);
	if (err)
		exit(fprintf(stderr,"stdin: %s\n",err));
	if (argc>1 && !strcmp(argv[1],"-e")) {
		printf("Executing..\n");
		-[ for each S in list stmts, begin ]
			exec_stmt(S,&global_frame);
		-[ end ]
	}
	
	printf("parse dump\n");
	-[ for each S in list stmts, begin ]
		print_stmt(S);
	-[ end ]

	return 0;
}


-[ lheader "parser.h" ]
-[ header "stdlib.h" ]
-[ header "stdio.h" ]
-[ lheader "table.h" ]
-[ lheader "functions.h" ]

